-- je dois hook puis creer un updater pour savoir quand lancer le son
if not AudioKillstreak then return end

Hooks:PostHook(HUDManager, "_setup_player_info_hud_pd2", "Counter", function(self, ...)
    self.vasimarchesalemerde = ComboCounter:new(managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2))
    self:add_updator("Counter_Updater", callback(self.vasimarchesalemerde, self.vasimarchesalemerde, "update"))
end)

function HUDManager:ComboCounterCrossLua()
    self.vasimarchesalemerde:OnKill()
end
function HUDManager:HeadshotCrossLua()
    if AudioKillstreak.Settings.headshot_toggle then
    self.vasimarchesalemerde:OnHeadshot()
    end
end

function HUDManager:GetKillstreak()
    return self.vasimarchesalemerde:GetBestKillStreak()
end

ComboCounter = ComboCounter or class()
ComboCounter._sndpath = ModPath .. "assets/snd/" 
ComboCounter._palierpath = ModPath .. "assets/snd/paliers/"


function ComboCounter:init(hud)
    --mettre une variable comme ca evite de faire appel dans les autre fonction alors que update recup deja le temps de l'app
    self._t = 0
    -- -1 car le mec n'a pas encore tuer
    self._last_kill_time = -1
    -- le temps entre chaque kill (mettre un menu pour modifier tous ca)
    self._time_buffer = self:getTime()
    -- 
    self._down = 0
    --
    if not blt.xaudio.issetup() then
        blt.xaudio.setup()
    end
    --
    self._src = XAudio.Source:new()
    --les sons
    self._son = {
        [-1] = {
            sfx = ComboCounter._sndpath .. "0.ogg",
        },
        [1] = {
            sfx = ComboCounter._sndpath .. "2.ogg",
        },
        [2] = {
            sfx = ComboCounter._sndpath .. "3.ogg",
        },
        [3] = {
            sfx = ComboCounter._sndpath .. "4.ogg",
        },
        [4] = {
            sfx = ComboCounter._sndpath .. "5.ogg",
        },
        [5] = {
            sfx = ComboCounter._sndpath .. "6.ogg",
        },
        [6] = {
            sfx = ComboCounter._sndpath .. "7.ogg",
        },
        [7] = {
            sfx = ComboCounter._sndpath .. "8.ogg",
        },
        [8] = {
            sfx = ComboCounter._sndpath .. "9.ogg",
        },
        [9] = {	
            sfx = ComboCounter._sndpath .. "10.ogg",
        }
    }
    self._palier = {
        [-1] = {
            sfx = ComboCounter._palierpath .. "0.ogg",
            kill = -1,
        },
        [0] = {
            sfx = ComboCounter._palierpath .. "1.ogg",
            kill = 1,
        },
        [1] = {
            sfx = ComboCounter._palierpath .. "2.ogg",
            kill = 2,
        },
        [2] = {
            sfx = ComboCounter._palierpath .. "3.ogg",
            kill = 3,
        },
        [3] = {
            sfx = ComboCounter._palierpath .. "4.ogg",
            kill = 5,
        },
        [4] = {
            sfx = ComboCounter._palierpath .. "5.ogg",
            kill = 10,
        },
        [5] = {
            sfx = ComboCounter._palierpath .. "6.ogg",
            kill = 20,
        },
        [6] = {
            sfx = ComboCounter._palierpath .. "7.ogg",
            kill = 50,
        },
        [7] = {
            sfx = ComboCounter._palierpath .. "8.ogg",
            kill = 75,
        },
        [8] = {
            sfx = ComboCounter._palierpath .. "9.ogg",
            kill = 100
        },
        [9] = {	
            sfx = ComboCounter._palierpath .. "10.ogg",
            kill = 150
        },
        [10] = {	
            sfx = ComboCounter._palierpath .. "11.ogg",
            kill = 200
        },
        [11] = {	
            sfx = ComboCounter._palierpath .. "12.ogg",
            kill = 250
        },
        [12] = {	
            sfx = ComboCounter._palierpath .. "13.ogg",
            kill = 500
        },
        [13] = {	
            sfx = ComboCounter._palierpath .. "14.ogg",
            kill = 750
        },
        [14] = {	
            sfx = ComboCounter._palierpath .. "15.ogg",
            kill = 1000
        },
        [15] = {	
            sfx = ComboCounter._palierpath .. "16.ogg",
            kill = 2000
        }
    }
    --le compteur
    self._compteur = 0
    self._kills_AK = 0
    --les headshots
    self._headshot = XAudio.Source:new()
    self._headshot:set_buffer(XAudio.Buffer:new(ComboCounter._sndpath .. "hs.ogg"))

    blt.xaudio.listener:setposition(0, 0, 0)
    blt.xaudio.listener:setorientation(1, 0, 0,  0, 1, 0)

    --le choix du joueur
    self._choix = AudioKillstreak.Settings.audio_killstreak_choice
    --le best killstreak res a chaque appel de ini donc chaque nouveau casse ?
    self._bestKillStreak = 0
end

function ComboCounter:getTime()
    return 3
end

--updater
function ComboCounter:update(t,dt)
    --deja mettre a jour le _t car lui ne peux s'update que ici
    self._t = t

    local player = managers.player:player_unit()

	if not alive(player) then
		return
	end
    local choix_du_joueur = AudioKillstreak.Settings.audio_killstreak_choice

    --#region Choix du joueur == reset
    if choix_du_joueur~=self._choix then
        self._choix = choix_du_joueur
        self._kills_AK = 0
        self._compteur = 0
        self._last_kill_time = -1
        self._bestKillStreak = 0
    end
    --#endregion

    --#region Si tu veux que le son ce joue a la fin et que le combo ce break au bout de x temps c'est ici
    if choix_du_joueur==1 then
        -- faut regarder si le last kill ne depasse pas le temps buffer et regarder si le mec a bien kill d'ou le -1
        if self._last_kill_time~=-1 and(self._time_buffer + self._last_kill_time) < self._t then
            -- depassement du temps donc joue le son si +=2 remet le kill a 0 
            self:PlaySound()
            self:SetBestKillStreak()
            self._kills_AK = 0
            self._last_kill_time = -1
        end 
    end
    --#endregion

    --#region Si tu veux que le son se joue entre chaque palier mais que le combo se break au bout de x temps c'est ici
    if choix_du_joueur==2 then
        if self._last_kill_time~=-1 and self._kills_AK>=5 and(self._time_buffer + self._last_kill_time) > self._t then
            self._compteur= self._compteur+1
            self._kills_AK =  self._kills_AK - 5
            self:PlaySound()
        else 
            if ((self._time_buffer + self._last_kill_time) < self._t and self._kills_AK~=0) or ((self._time_buffer + self._last_kill_time) < self._t and self._compteur~=0) then
                self:mort()
            end
        end
    end
    --#endregion

    --#region Si tu veux que le son se joue tous le temps bah c'est la et que la streak ce break quand tu tombe c'est la
    if choix_du_joueur==3 then
        if self._kills_AK>=5 then
            self._compteur= self._compteur+1
            self._kills_AK = self._kills_AK - 5
            self:PlaySound()
        end

        if (managers.player:current_state() == "arrested" and managers.player:current_state() == "bleed_out" or managers.player:current_state() == "incapacitated" or managers.player:current_state()== managers.player._custody_state)and self._down == 0 then
		    self:mort()
            self._down = 1
	    end

        if managers.player:current_state() == "standard" and self._down == 1 then
            self._down = 0
	    end
    end
    --#endregion
    
    --#region pour des paliers de sons toujours plus grand au fur et a mesure de la partie
    if choix_du_joueur>3 then
        if self._compteur<16 and (self._kills_AK>self._palier[self._compteur].kill or self._kills_AK==self._palier[self._compteur].kill)then
            self:PlaySoundPalier()
            self._compteur = self._compteur + 1
        end
        if self._compteur>=16 and self._kills_AK>=self._palier[15].kill*self._compteur then
            self:PlaySoundPalier()
            self._compteur = self._compteur + 1
        end
    end
    --#endregion
end

function ComboCounter:mort()
    -- si le mec meurt tout retombe a 0
    self:SetBestKillStreak()
    self._compteur = -1
    self._kills_AK = 0
    self:PlaySound()
end


function ComboCounter:OnKill()
    -- des que je tue je met +1 au kill_ak je met last kill time = time 
    self._kills_AK = self._kills_AK + 1
    self._last_kill_time =self._t
end

-- fonction qui joue les sons
function ComboCounter:PlaySound()
    if not blt.xaudio.issetup() then
        blt.xaudio.setup()
    end
    buffer = nil
    if self._compteur == -1 then
        self._compteur = 0
        buffer = XAudio.Buffer:new(self._son[-1].sfx)
    end
    if self._compteur>=9 then
        buffer = XAudio.Buffer:new(self._son[9].sfx)
    
    end
    if 0<self._compteur and self._compteur<9 then
         buffer =XAudio.Buffer:new(self._son[self._compteur].sfx)
    end
    
    if buffer ~= nil then    
        self._src = XAudio.UnitSource:new(XAudio.PLAYER,buffer)
        if self._src ~= nil then
            if not self._src:get_state()==XAudio.Source.PLAYING  then
                self._src:stop()
            end
            self._src:set_volume(AudioKillstreak.Settings.audio_killstreak_volume/100)
            self._src:play()
        end
    end
end

function ComboCounter:OnHeadshot()
    self._headshot:stop()
    self._headshot:set_position(0,0,0)
    self._headshot:set_volume(AudioKillstreak.Settings.audio_killstreak_volume/100)
    self._headshot:play()
end

function ComboCounter:PlaySoundPalier()
    if not blt.xaudio.issetup() then
        blt.xaudio.setup()
    end
    buffer = nil
    if self._compteur == -1 then
        self._compteur = 0
        buffer = XAudio.Buffer:new(self._palier[-1].sfx)
    end
    if self._compteur>=15 then
        buffer = XAudio.Buffer:new(self._palier[15].sfx)
    
    end
    if 0<self._compteur and self._compteur<15 then
         buffer =XAudio.Buffer:new(self._palier[self._compteur].sfx)
    end
    
    if buffer ~= nil then   
        self._src = XAudio.UnitSource:new(XAudio.PLAYER,buffer) 
        if self._src ~= nil then
            if not self._src:get_state()==XAudio.Source.PLAYING  then
                self._src:stop()
            end
            self._src:set_volume(AudioKillstreak.Settings.audio_killstreak_volume/100)
            self._src:play()
        end
    end
end

function ComboCounter:GetBestKillStreak()
    self:SetBestKillStreak()
    return self._bestKillStreak
end

function ComboCounter:SetBestKillStreak()
    if self._choix <3 then
        if self._bestKillStreak < self._kills_AK + 5 * self._compteur then
            self._bestKillStreak = self._kills_AK + 5 * self._compteur
        end
    else
        if self._bestKillStreak < self._kills_AK then
            self._bestKillStreak = self._kills_AK
        end
    end
end